# Esercizio Outliers (PNL)

# DATI
# Punti
param n;				# Numero di punti
set Punti := 1..n;		# Set di punti
param x {Punti};		# Coordinata x di ogni punto
param y {Punti};		# Coordinata y di ogni punto
# Limite al n. di outliers
param K := 6;

# VARIABILI
# Retta di regressione
var m;					# Pendenza
var q;					# Intercetta
# Errore quadratico per ogni punto
var sqerr {i in Punti} = (y[i] - (m*x[i]+q))^2;
# Outliers
var z {Punti} binary;	# Selezione outliers 

# VINCOLI
subject to Numero_outliers:
  sum {i in Punti} z[i] <= K;

# OBIETTIVO
minimize f: sum {i in Punti} (1-z[i]) * sqerr[i];

end;

